Category: Estimated time: 80.00 hours
Experiment: -

Description

We believe that there could be advantages to separating the existing artdaq code into two or more software packages. It's not totally
clear what the best separation would be, but there are a couple of use cases that illustrate the issues:

1. art and a couple of classes from artdaq are used for the NOvA data-driven trigger. The current organization of the code means
that when NOVA folks want a new art release, a new artdaq release needs to be cut and released in order for the new version of
art to be made available to the NOvA DDT. If instead there were a separate package that had the input source (or whatever the
DDT needs from artdag), and this new package depended on art, but not artdag, then the artificial strong coupling between the
NOvA DDT and artdaq would be broken.

2. The uBooNE DAQ uses a couple of utility classes from artdaq, but it does not use art or ROOT. It would be nice to be able to
use the needed classes from artdaq in the uBooNE DAQ code without bringing in a number of unnecessary heavy-weight
packages.

History

#1 - 05/21/2014 03:41 PM - Kurt Biery

Some background information on the use of artdaq in the NOvA DDT...
Primary source files:

e https://cdcvs.fnal.gov/redmine/projects/novaddt/repository/show/trunk/DDTproto
¢ novadag-ctrl-master.fnal.gov:/nova/novaddt/novaddt/releases/development/DDTproto

Files that are used from artdag:

[novadag@novadag-ctrl-master DDTproto]$ findc artdag | grep include | cut -d':' —-f2 | sort -u
#include "artdag/DAQdata/Debug.hh"

#include "artdag/DAQdata/FragmentGenerator.hh"

#include "artdag/DAQdata/Fragment.hh"

#include "artdag/DAQdata/Fragments.hh"

#include "artdag/DAQdata/GeneratorMacros.hh"

#include "artdag/DAQdata/makeFragmentGenerator.hh"

#include "artdag/DAQdata/RawEvent.hh"

#include "artdag/DAQrate/GlobalQueue.hh"

include SoftRelTools/arch_spec_artdag.mk

#2 - 06/12/2014 02:53 PM - Kurt Biery

- Status changed from New to Assigned

- Assignee set to Kurt Biery

- % Done changed from 0 to 10

I've started to summarize some ideas on how to proceed here.
I've spent ~9 hours so far on this task through 14:45 today.

#3 - 07/28/2014 10:11 AM - Kurt Biery
- Target version changed from 576 to vi_09_00

#4 - 07/28/2014 11:14 AM - Kurt Biery

This is currently implemented as a separation into artdag-core (which depends on art) and artdaq (which depends on artdag-core, MPI, xmlrpc, etc.)
https://cdcvs.fnal.gov/redmine/projects/novaddt/repository/show/trunk/DDTproto
https://cdcvs.fnal.gov/redmine/projects/artdaq/wiki/Package_splitting_ideas

#5 - 07/28/2014 11:23 AM - Kurt Biery

The new artdaq-core repo is a secondary one in the artdag Redmine project.
Here is an email that | sent on this subject:

After thinking about this a little more, | decided to split off only one package: artdag-core. If we decide that we need multiple packages
underneath artdagq later, we can create them then (with sufficient knowledge of why they are needed.)

On 7/21/2014 4:55 PM, Kurt Biery wrote:

Hi guys,
As we've discussed, we're splitting artdaq into artdaq, artdag-core, and artdag-generators. Those are git repository names. UPS products
can't have hyphens (from what | can tell). This means that the associated UPS products will be artdaq, artdag_core, and artdaq_generators.

When user code includes header files from these packages, that will look like '#include "artdaqg-core/Data/Fragments.hh™.

So far, I've kept the "artdaq" namespace for all of the code in these three packages, and my sense is that we should use that model
elsewhere. (E.g. namespace="lbne" for both lbne-raw-data and lbne-artdaq).

This model (hyphens in repos and underscores in UPS product names) seems to be used elsewhere. | just wanted to mention it in case
any of you wanted to talk about this more before we get too far down this path.
Kurt

#6 - 07/28/2014 11:24 AM - Kurt Biery
- Due date set to 07/31/2014
- Status changed from Assigned to Resolved

- % Done changed from 10 to 90

| calculate that | spent another ~32 hours on this task. This brings the total effort up to 41 hours.

#7 - 07/28/2014 11:29 AM - Kurt Biery

- Status changed from Resolved to Closed
